/* Name: main.c
 * Author: Michael Koehler
 * Copyright: <insert your copyright message here>
 * License: <insert your license reference here>
 */

#include "main.h"
#include "uart.h"
#include "adc.h"
#include "lookup_table.h"

//Laufvariable zum Durchlaufen der Lookup-Table
volatile uint8_t i=0;

int main(void)
{
    setUpAvr();
    
    for(;;){
		if (uart_str_complete != 0) {
			// uart string komplett, hier dann auswerten!
            
			// uart-string ausgewertet, Flag setzen fuer neuen Empfang
			uart_str_complete = 0;
		}
        sleep_mode();
    }
    return 0;   /* wird nie erreicht */
}

void setUpAvr(void){
    // setUp UART, Parameter siehe uart.h/.c vornehmen
    // ISR(USART_RX_vect) in uart.c
    uartSetup(19200UL, ONE, NONE, EIGHT);
    sendString_p(PSTR("UART init completed!\r\n"));
    // setUp ADC, Parameter siehe adc.h/.c
    // ISR(ADC_vect) in adc.c
    adcInit(PSC128, AVCC, RIGHT);
	sendString_p(PSTR("ADC init completed!\r\n"));
	// PWM einstellen
	TCCR1A = (1 << COM1A1)|(1 << WGM10);
	TCCR1B = (1 << WGM12)|(1 << CS10);
	TIMSK1 = (1 << TOIE1);
	OCR1A = pgm_read_byte(&sin_wave[0]);
	//PWM-Signal wird an Port-Pin PB1 anliegen
	DDRB = (1 << PB1);
    // andere Initialisierungen
	// nicht verwendete Module abschalten
	PRR = (1 << PRTIM2)|(1 << PRSPI)|(1 << PRADC);
	// Sleepmode einstellen
	set_sleep_mode(SLEEP_MODE_IDLE);
    // enable interrupts
    sei();
}
ISR(TIMER1_OVF_vect){
	// Neuen Wert ins PWM-Register laden
	OCR1A = pgm_read_byte(&sin_wave[i]);
	// i um eins erhoehen fuer einen 50Hz Sinus,
	// wird i um zwei erhoeht ergibt sich ein 100Hz Sinus
	// um drei erhoeht ergibt ein 150Hz Sinus usw.
	i += 1;
	// pruefen ob das Ende der Lookup-Table erreicht ist, 
	// wenn ja zurueck zum Anfang
	if(i > sizeof(sin_wave)) i=0;
}